//initializing all the custom sound effects and their captions
freeslot("sfx_cshflp", "sfx_akuded", "sfx_akuspn", "sfx_cshpew", "sfx_ashcsh", 
		"sfx_cshxry", "sfx_cshngl", "sfx_cshfrz", "sfx_crdrwn", "sfx_cshfal", 
		"sfx_woah", "sfx_cshsld", "sfx_cshspn", "sfx_cshft1", "sfx_cshft2", 
		"sfx_boxbrk", "sfx_ntrbnc", "sfx_tntcnt", "sfx_rngbnc", "sfx_swchht")
sfxinfo[sfx_cshflp].caption = "Pre-slam"
sfxinfo[sfx_akuded].caption = "Aku-Aku got hit!"
sfxinfo[sfx_akuspn].caption = "Aku-Aku power up"
sfxinfo[sfx_cshpew].caption = "Flung'd!"
sfxinfo[sfx_ashcsh].caption = "Someone overcooked a marsupial"
sfxinfo[sfx_cshxry].caption = "How shocking..."
sfxinfo[sfx_cshngl].caption = "He's going towards the light"
sfxinfo[sfx_cshfrz].caption = "Frozen in space"
sfxinfo[sfx_crdrwn].caption = "Crash meets Davy Jones"
sfxinfo[sfx_cshfal].caption = "'HELP!'"
sfxinfo[sfx_woah].caption = "woah"
sfxinfo[sfx_cshsld].caption = "Sliding"
sfxinfo[sfx_cshspn].caption = "Tornado Spin"
sfxinfo[sfx_cshft1].caption = "Footsteps 1"
sfxinfo[sfx_cshft2].caption = "Footsteps 2"
sfxinfo[sfx_boxbrk].caption = "Box break"
sfxinfo[sfx_ntrbnc].caption = "Nitro box bouncing"
sfxinfo[sfx_tntcnt].caption = "TNT box counting down..."
sfxinfo[sfx_rngbnc].caption = "Ring box bounce"
sfxinfo[sfx_swchht].caption = "Nitro switch activated"

//freesloting custom sprites
freeslot("SPR_AKU_", "SPR_BLBX", "SPR_NTBX", "SPR_TNBX", "SPR_TNBK", "SPR_AKBX", 
		"SPR_RGBX", "SPR_NTST")

//initializing custom states
freeslot("S_AKU_IDLE", "S_BLANKSTATE", "S_BLANKBOX1", "S_BLANKBOX2", 
		"S_NITROBOX", "S_TNTBOX", "S_TNTCOUNT", "S_BLANKTNT", "S_AKU_BOX", 
		"S_RINGCRATE", "S_RINGBOXHIT", "S_NITROSTEEL", "S_BLANKSTEEL", 
		"S_LIFECRATE")
states[S_AKU_IDLE] = {
	sprite = SPR_AKU_,
	frame = A,
	tics = -1,
	nextstate = S_AKU_IDLE
}
states[S_BLANKSTATE] = {
	tics = 40
}
states[S_BLANKBOX1] = {
	sprite = SPR_BLBX,
	frame = A,
	tics = -1,
	nextstate = S_BLANKBOX1
}
states[S_BLANKBOX2] = {
	sprite = SPR_BLBX,
	frame = A,
	tics = 1,
	nextstate = S_BLANKSTATE,
	action = A_MonitorPop
}
states[S_NITROBOX] = {
	sprite = SPR_NTBX,
	frame = A,
	tics = -1,
	nextstate = S_NITROBOX
}
states[S_TNTBOX] = {
	sprite = SPR_TNBX,
	frame = A,
	tics = -1,
	nextstate = S_TNTBOX
}
states[S_TNTCOUNT] = {
	sprite = SPR_TNBK,
	frame = FF_ANIMATE|A,
	tics = 105,
	var1 = 3,
	var2 = 35,
	nextstate = S_BLANKTNT
}
states[S_BLANKTNT] = {
	tics = 1
}
states[S_AKU_BOX] = {
	sprite = SPR_AKBX,
	frame = A,
	tics = -1,
	nextstate = S_AKU_BOX
}
states[S_RINGCRATE] = {
	sprite = SPR_RGBX,
	frame = A,
	tics = -1,
	nextstate = S_RINGCRATE
}
states[S_RINGBOXHIT] = {
	sprite = SPR_RGBX,
	frame = A,
	tics = 2,
	nextstate = S_RINGCRATE
}
states[S_NITROSTEEL] = {
	sprite = SPR_NTST,
	frame = A,
	tics = -1,
	nextstate = S_NITROSTEEL
}
states[S_BLANKSTEEL] = {
	sprite = SPR_NTST,
	frame = B,
	tics = -1,
	action = A_GoldMonitorPop,
	nextstate = S_BLANKSTEEL
}
//have to make a modified version of A_1upThinker so that it actually works
function A_1upCrateThinker(actor)
	//_1upThinker(actor)
	//actor.sprite = SPR_BLBX
	local temp
	local closest = INT32_MAX
	for player in players.iterate do
		temp = P_AproxDistance(player.mo.x - actor.x, player.mo.y - actor.y)
		if temp < closest and player and player.valid and player.mo and 
				player.mo.valid and player.playerstate == PST_LIVE
			closest = temp
			actor.target = player.mo
		end
	end
	if not actor.target or not actor.target.valid// or skins[actor.target.skin].sprites[SPR2_LIFE].numframes == 0
		if actor.tracer
			P_RemoveMobj(actor.tracer)
			actor.target = nil
		end
		return
	end
	if not actor.tracer or not actor.tracer.valid
		actor.tracer = P_SpawnMobjFromMobj(actor, 0, 0, 0, MT_OVERLAY)
		actor.tracer.skin = skins[actor.target.player.skin]
	end
	actor.tracer.color = actor.target.color
	actor.tracer.skin = skins[actor.target.player.skin]
	actor.tracer.state = S_PLAY_WALK
end
states[S_LIFECRATE] = {
	sprite = SPR_BLBX,
	frame = A,
	tics = 1,
	action = A_1upCrateThinker,
	nextstate = S_LIFECRATE
}

//initializing all the custom objects used
freeslot("MT_AKUAKU", "MT_BLANKBOX", "MT_NITROBOX", "MT_TNTBOX", "MT_AKUAKUBOX", 
		"MT_RINGCRATE", "MT_NITROSTEEL", "MT_LIFECRATE")
mobjinfo[MT_AKUAKU] = {
	spawnstate = S_AKU_IDLE,
	spawnhealth = 1,
	seestate = S_AKU_IDLE,
	speed = 8 * FRACUNIT,
	radius = 10 * FRACUNIT,
	height = 32 * FRACUNIT,
	flags = MF_NOCLIP|MF_NOGRAVITY|MF_SCENERY|MF_NOCLIPHEIGHT
}
mobjinfo[MT_BLANKBOX] = {
	spawnstate = S_BLANKBOX1,
	spawnhealth = 1,
	seestate = S_BLANKBOX1,
	deathstate = S_BLANKBOX2,
	deathsound = sfx_boxbrk,
	radius = 20 * FRACUNIT,
	height = 45 * FRACUNIT,
	flags = MF_SOLID|MF_SHOOTABLE|MF_MONITOR
}
mobjinfo[MT_NITROBOX] = {
	spawnstate = S_NITROBOX,
	spawnhealth = 1,
	seestate = S_NITROBOX,
	radius = 20 * FRACUNIT,
	height = 45 * FRACUNIT,
	flags = MF_SOLID|MF_SHOOTABLE|MF_MONITOR
}
mobjinfo[MT_TNTBOX] = {
	spawnstate = S_TNTBOX,
	spawnhealth = 1,
	seestate = S_TNTBOX,
	deathstate = S_BLANKTNT,
	radius = 20 * FRACUNIT,
	height = 45 * FRACUNIT,
	flags = MF_SOLID|MF_SHOOTABLE|MF_MONITOR
}
mobjinfo[MT_AKUAKUBOX] = {
	spawnstate = S_AKU_BOX,
	spawnhealth = 1,
	seestate = S_AKU_BOX,
	deathstate = S_BLANKBOX2,
	deathsound = sfx_boxbrk,
	radius = 20 * FRACUNIT,
	height = 45 * FRACUNIT,
	damage = MT_PITY_ICON,
	flags = MF_SOLID|MF_SHOOTABLE|MF_MONITOR
}
mobjinfo[MT_RINGCRATE] = {
	spawnstate = S_RINGCRATE,
	spawnhealth = 1,
	seestate = S_RINGCRATE,
	deathstate = S_BLANKBOX2,
	deathsound = sfx_boxbrk,
	radius = 20 * FRACUNIT,
	height = 45 * FRACUNIT,
	flags = MF_SOLID|MF_SHOOTABLE|MF_MONITOR
}
mobjinfo[MT_NITROSTEEL] = {
	spawnstate = S_NITROSTEEL,
	spawnhealth = 1,
	seestate = S_NITROSTEEL,
	deathstate = S_BLANKSTEEL,
	deathsound = sfx_swchht,
	radius = 20 * FRACUNIT,
	height = 45 * FRACUNIT,
	flags = MF_SOLID|MF_SHOOTABLE|MF_MONITOR
}
mobjinfo[MT_LIFECRATE] = {
	spawnstate = S_LIFECRATE,
	spawnhealth = 1,
	seestate = S_LIFECRATE,
	deathstate = S_BLANKBOX2,
	deathsound = sfx_boxbrk,
	radius = 20 * FRACUNIT,
	height = 45 * FRACUNIT,
	flags = MF_SOLID|MF_SHOOTABLE|MF_MONITOR
}