local JumpManager = CrashAddon.JumpManager

//this makes the nitro box bounce up occasionally
local function NitroBounce(mo)
	//this kills the nitro box id the nitro detonator has been activated
	if CrashAddon.nitrodetonator == 0
		P_KillMobj(mo)
		return
	end
	if P_RandomChance(FRACUNIT / 100) and P_IsObjectOnGround(mo)
		JumpManager(mo, 5 * FRACUNIT)
		S_StartSound(mo, sfx_ntrbnc)
	end
end

//this automatically kills the nitro box when touched
local function NitroNoTouch(thing, tmthing)
	if tmthing.type == MT_PLAYER
		if tmthing.z >= thing.z - thing.height and tmthing.z <= thing.z + 
				thing.height
			P_KillMobj(thing)
		end
	end
end

//this makes the box explode when it dies
local function NitroDeath(target)
	if target.crashmapbox
		CrashAddon.boxcount = $ - 1
	end
	local nitroexplode = P_SpawnMobjFromMobj(target, 0, 0, 0, MT_TNTBARREL)
	nitroexplode.colorized = true
	nitroexplode.color = SKINCOLOR_GREEN
	P_KillMobj(nitroexplode)
end

//this determines what happens when the nitro detonator has been activated
local function NitroSwitch(target, inflictor)
	CrashAddon.nitrodetonator = 0
end

//has to be a function because signposts always spawn before their angle is set
local function NitroSwitchPos(mo)
	if mo.tracer and mo.tracer.type == MT_SIGN and mo.changepos <= 0
		P_MoveOrigin(mo, mo.tracer.x + P_ReturnThrustX(mo, mo.tracer.angle, 
				150 * FRACUNIT), mo.tracer.y + P_ReturnThrustY(mo, 
				mo.tracer.angle, 150 * FRACUNIT), mo.tracer.z)
		CrashAddon.nitrodetonator = 1
		mo.tracer = nil
		mo.changepos = nil
	elseif mo.changepos
		mo.changepos = $ - 1
	end
end

//hooks
addHook("MobjThinker", NitroBounce, MT_NITROBOX)
addHook("MobjCollide", NitroNoTouch, MT_NITROBOX)
addHook("MobjDeath", NitroDeath, MT_NITROBOX)
addHook("MobjDeath", NitroSwitch, MT_NITROSTEEL)
addHook("MobjThinker", NitroSwitchPos, MT_NITROSTEEL)