local SoundTrigger = CrashAddon.SoundTrigger
local StateSetter = CrashAddon.StateSetter
local JumpManager = CrashAddon.JumpManager

//this determines if the box blows up immediately or starts the countdown
local function TNTTrigger(target, inflictor)
	if inflictor and inflictor.valid
		if inflictor.type == MT_PLAYER and inflictor.player and 
				inflictor.player.pflags & PF_JUMPED
			StateSetter(target, S_TNTCOUNT)
			S_StartSound(target, sfx_rngbnc)
			JumpManager(inflictor, 7 * FRACUNIT)
			return false
		else
			return true
		end
	end
end

//this handles what happens during the countdown
local function TNTSound(mo)
	if mo.state == S_TNTCOUNT
		SoundTrigger(mo, sfx_tntcnt)
		A_ForceStop(mo, 0)
	elseif mo.state == S_BLANKTNT
		P_KillMobj(mo)
	end
end

//this makes the tnt box explode upon death
local function TNTDeath(target)
	if target.crashmapbox
		CrashAddon.boxcount = $ - 1
	end
	local tntexplode = P_SpawnMobjFromMobj(target, 0, 0, 0, MT_TNTBARREL)
	P_KillMobj(tntexplode)
end

//hooks
addHook("ShouldDamage", TNTTrigger, MT_TNTBOX)
addHook("MobjThinker", TNTSound, MT_TNTBOX)
addHook("MobjDeath", TNTDeath, MT_TNTBOX)