//this is where the magic happens, all the death animations are done here
local function DeathAnimTrigger(target, inflictor, source, damagetype)
	if target.skin != "crashbandi"
		return
	end
	
	local deathmo = target.player.crashban.deathsprite
	deathmo = P_SpawnMobjFromMobj(target, 0, 0, 0, MT_ARIDDUST)
	deathmo.deathtype = damagetype
	if inflictor != nil
		if inflictor.type == MT_TNTBARREL and damagetype != DMG_NUKE
			deathmo.deathtype = DMG_NUKE
		end
	end
end

local function OvercookedMarsupial(mo)
	if not mo.deadsound
		S_StartSound(mo, sfx_ashcsh)
		mo.colorized = true
		mo.color = SKINCOLOR_BLACK
		mo.deadsound = true
	end
	CrashJumpManager(mo, 2 * FRACUNIT / 3)
	if not (mo.state == S_PLAY_DEAD)
		mo.state = S_PLAY_DEAD
	end
end
local function RedneckXRay(mo)
	if not mo.deadsound
		S_StartSound(mo, sfx_cshxry)
		mo.deadsound = true
	end
	CrashJumpManager(mo, 2 * FRACUNIT / 3)
	if mo.animtimer % 2 == 0
		mo.colorized = true
	else
		mo.colorized = false
	end
	if not (mo.state == S_PLAY_DEAD)
		mo.state = S_PLAY_DEAD
	end
end
local function OrangePOPsicle(mo)
	if not mo.deadsound
		print("insert popped bandicoot here")
		mo.deadsound = true
	end
	CrashJumpManager(mo, 2 * FRACUNIT / 3)
end
local function CrashTheJigsaw(mo)
	if not mo.deadsound
		print("insert pieces of bandicoot here")
		mo.deadsound = true
	end
	CrashJumpManager(mo, 2 * FRACUNIT / 3)
end
local function AngelDeath(mo)
	if not mo.deadsound
		S_StartSound(mo, sfx_cshdth)
		S_StartSound(mo, sfx_cshngl)
		mo.deadsound = true
	end
	CrashJumpManager(mo, 5 * FRACUNIT)
	if not (mo.state == S_PLAY_DEAD)
		mo.state = S_PLAY_DEAD
	end
end
local function MostTameSpaceDeath(mo)
	if not mo.deadsound
		S_StartSound(mo, sfx_cshfrz)
		mo.colorized = true
		mo.color = SKINCOLOR_ICY
		mo.deadsound = true
	end
	CrashJumpManager(mo, 2 * FRACUNIT / 3)
	if not (mo.state == S_PLAY_DRWN)
		mo.state = S_PLAY_DRWN
	end
end
local function Waterlogged(mo)
	if P_InSpaceSector(mo)
		mo.deathtype = DMG_SPACEDROWN
		return
	end
	if not mo.deadsound
		S_StartSound(mo, sfx_crdrwn)
		mo.deadsound = true
	end
	CrashJumpManager(mo, -2 * FRACUNIT)
	if not (mo.state == S_PLAY_DRWN)
		mo.state = S_PLAY_DRWN
	end
end
local function WinglessFlight(mo)
	if not mo.deadsound
		S_StartSound(mo, sfx_cshdth)
		S_StartSound(mo, sfx_cshfal)
		CrashJumpManager(mo, -50 * FRACUNIT)
		mo.deadsound = true
	end
	if not (mo.state == S_PLAY_FALL)
		mo.state = S_PLAY_FALL
	end
end
local function FlatBandicoot(mo)
	if not mo.deadsound
		S_StartSound(mo, sfx_cshdth)
		mo.deadsound = true
	end
	CrashJumpManager(mo, 2 * FRACUNIT / 3)
	mo.frame = $ | FF_FLOORSPRITE
	if not (mo.state == S_PLAY_DEAD)
		mo.state = S_PLAY_DEAD
	end
end
local DeathTypes = {
	[DMG_FIRE] = OvercookedMarsupial,
	[DMG_ELECTRIC] = RedneckXRay,
	[DMG_SPIKE] = OrangePOPsicle,
	[DMG_NUKE] = CrashTheJigsaw,
	[DMG_INSTAKILL] = AngelDeath,
	[DMG_SPACEDROWN] = MostTameSpaceDeath,
	[DMG_DROWNED] = Waterlogged,
	[DMG_DEATHPIT] = WinglessFlight,
	[DMG_CRUSHED] = FlatBandicoot
}

local ValidDeathTypes = {
	[DMG_FIRE] = true,
	[DMG_ELECTRIC] = true,
	[DMG_SPIKE] = true,
	[DMG_NUKE] = true,
	[DMG_INSTAKILL] = true,
	[DMG_SPACEDROWN] = true,
	[DMG_DROWNED] = true,
	[DMG_DEATHPIT] = true,
	[DMG_CRUSHED] = true
}

local function DeathAnimations(player)
	if not CrashSkinCheck(player)
		return
	end
	
	if player.playerstate == PST_DEAD
		player.mo.flags = $ & ~MF_NOGRAVITY
		if ValidDeathTypes[player.mo.deathtype]
			DeathTypes[player.mo.deathtype](player.mo)
		else
			AngelDeath(player.mo)
		end
	end
end

//hooks
addHook("MobjDeath", DeathAnimTrigger, MT_PLAYER)
//addHook("PlayerThink", DeathAnimations)