local CrashSkinCheck = CrashAddon.CrashSkinCheck
local CootOnGround = CrashAddon.CootOnGround

//custom function, a modified version of Emmette's footsteps code
local function FootstepCue(player, fram1, fram2)
	local crashban = player.crashban
	
	if crashban.currentfram != (player.mo.frame & FF_FRAMEMASK)
		if (player.mo.frame & FF_FRAMEMASK) == fram1
			S_StartSound(player.mo, sfx_cshft1)
		elseif (player.mo.frame & FF_FRAMEMASK) == fram2
			S_StartSound(player.mo, sfx_cshft2)
		end
		crashban.currentfram = player.mo.frame & FF_FRAMEMASK
	end
end

//this controls when the footsteps play based on animation
local function Footsteps(player)
	if not CrashSkinCheck(player)
		return
	end
	
	if CootOnGround(player.mo)
		if player.mo.state == S_PLAY_WALK
			FootstepCue(player, 2, 6)
		elseif player.mo.state == S_PLAY_RUN
			FootstepCue(player, 1, 3)
		end
	end
	//also imma put extra visual effects for crash's super form right here
	if player.powers[pw_super] and leveltime % 5 == 0
		local crashsprks = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_IVSP)
		crashsprks.colorized = true
		crashsprks.frame = $ | FF_ADD
		crashsprks.color = SKINCOLOR_GOLDENROD
	end
end

//hooks
addHook("PlayerThink", Footsteps)