local CrashSkinCheck = CrashAddon.CrashSkinCheck
local JumpManager = CrashAddon.JumpManager
local FailVibeCheck = CrashAddon.FailVibeCheck
local CootOnGround = CrashAddon.CootOnGround
local IsFalling = CrashAddon.IsFalling

/*has its own version of the ActionButton function since the spin move is on
different button from crawl/slide and body slam*/
local function ActionButton(player)
	if player.crash_consolemode
		return BT_SPIN
	else
		return BT_CUSTOM1
	end
end

//local variable to keep track of how many max button presses are allowed for glide
local max_glide_press = 8

local function TornadoSpinGlide(player)
	if not CrashSkinCheck(player)
		return
	end
	
	local crashban = player.crashban
	//this resets everything and prevents moves if crash fails the vibe check
	if FailVibeCheck(player)
		crashban.spincooldown = 0
		crashban.spinpress = false
		crashban.glidecounter = 0
		crashban.spintimer = 0
		return
	end
	
	if crashban.spincooldown <= 0
		//this makes crash start spinning when the button is pressed
		if player.cmd.buttons & ActionButton(player) and not 
				crashban.bodyslam and crashban.slidetimer <= 0 and not
				crashban.actionpress and not (player.pflags &
				PF_SPINNING) and crashban.faceplant <= 0
			if not crashban.spinpress
				if crashban.glidecounter < max_glide_press or 
						player.powers[pw_super]
					crashban.spintimer = TICRATE / 2
					S_StartSound(player.mo, sfx_cshspn)
					if CootOnGround(player.mo)
						crashban.glidecounter = max_glide_press
					else
						crashban.glidecounter = $ + 1
					end
				end
				crashban.spinpress = true
			end
		else
			crashban.spinpress = false
		end
		//this makes crash do damage and glide while the spin move is active
		if crashban.spintimer > 0
			if player.mo.state != S_PLAY_SPINDASH
				player.powers[pw_strong] = STR_ANIM|STR_ATTACK|STR_WALL|STR_SPIKE
				player.mo.state = S_PLAY_SPINDASH
			end
			if not CootOnGround(player.mo) and IsFalling(player.mo) and
					player.mo.momz != 0
				JumpManager(player.mo, -3 * FRACUNIT)
			end
			crashban.spintimer = $ - 1
		else
			if player.mo.state == S_PLAY_SPINDASH
				if CootOnGround(player.mo)
					player.mo.state = S_PLAY_WALK
				else
					player.mo.state = S_PLAY_FALL
				end
				crashban.spincooldown = TICRATE / 2
			end
			if CootOnGround(player.mo)
				crashban.glidecounter = 0
			elseif crashban.glidecounter > 0
				crashban.glidecounter = max_glide_press
			end
		end
	else
		if player.mo.state == S_PLAY_SPINDASH
			if CootOnGround(player.mo)
				player.mo.state = S_PLAY_WALK
			else
				player.mo.state = S_PLAY_FALL
			end
		end
		crashban.glidecounter = 0
		crashban.spincooldown = $ - 1
	end
end

//hooks
addHook("PlayerThink", TornadoSpinGlide)